"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.setMessages = setMessages;
exports.default = getMessage;
exports.KeysUsed = void 0;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var _debug = _interopRequireDefault(require("debug"));

var _get = _interopRequireDefault(require("lodash/get"));

var dbg = (0, _debug.default)('woonerf:message');
/**
 * Expose a Set of all the keys used
 */

var KeysUsed = new Set();
/**
 * Set the messages object
 */

exports.KeysUsed = KeysUsed;

function setMessages(newMessages) {
  messages = newMessages;
}

var messages = {};

if (process.env.MESSAGES) {
  setMessages(JSON.parse(process.env.MESSAGES));
}
/**
 * Requires a key, defaultMessage and parameters are optional
 */


function getMessage(key, defaultMessage, parameters) {
  if (defaultMessage == null) {
    defaultMessage = '';
    parameters = {};
  } else if ((0, _typeof2.default)(defaultMessage) === 'object') {
    parameters = defaultMessage;
    defaultMessage = '';
  } // Store the used key


  KeysUsed.add(key); // Get the message with "lodash/get" to allow nested keys ('noun.action' => {noun: {action: 'value'}})

  var msg = (0, _get.default)(messages, key, defaultMessage);
  var result = parameters ? replaceMessage(msg, parameters) : msg;
  dbg(key, result);
  return result;
}

function replaceMessage(msg, data) {
  return msg.replace(new RegExp('%\\((' + Object.keys(data).join('|') + ')\\)', 'g'), function (m, key) {
    return data.hasOwnProperty(key) ? data[key] : m;
  });
}

//# sourceMappingURL=message.js