"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createStore;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread"));

var _merge = _interopRequireDefault(require("lodash/merge"));

var _redux = require("redux");

var _reactRouterRedux = require("react-router-redux");

var configureStore = null;

if (process.env.NODE_ENV === 'production') {
  configureStore = require('./store.production');
} else if (process.env.NODE_ENV === 'test') {
  configureStore = require('./store.mock');
} else {
  configureStore = require('./store.development');
}

function createStore(reducers) {
  var configuredState = safeParse(process.env.STORE);
  var locallyStoredState = safeParse(window.localStorage ? window.localStorage.getItem('state') : {});
  var store = configureStore((0, _redux.combineReducers)((0, _objectSpread2.default)({
    routing: _reactRouterRedux.routerReducer
  }, reducers)), (0, _merge.default)(configuredState, locallyStoredState));
  return store;
}

function safeParse(str) {
  try {
    return JSON.parse(str) || {};
  } catch (e) {
    return {};
  }
}

module.exports = exports["default"];

//# sourceMappingURL=index.js